# This file is a template, and might need editing before it works on your project.
# Official docker image.
image: docker:latest

services:
  - docker:19.03.5-dind

variables:
  DOCKER_DRIVER: overlay
  CONTAINER_DB_TEST_IMAGE: $CI_REGISTRY_IMAGE:db-test

before_script:
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY

build-master:
  stage: build
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE" .
    - docker push "$CI_REGISTRY_IMAGE"
  only:
    - master

deploy-master-docker:
  stage: deploy
  script:
    - docker login -u "$DOCKER_REGISTRY_USER" -p "$DOCKER_REGISTRY_PASSWORD" $DOCKER_REGISTRY
    - docker build --pull -t "$DOCKER_REGISTRY_IMAGE" .
    - docker push "$DOCKER_REGISTRY_IMAGE"
  only:
    - master

build:
  stage: build
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
  except:
    - master

# db
.db-only-changes: &db-only-changes
    changes:
      - Dockerfile.db
      - Dockerfile.db-test
      - resources/templates/server_init/db_templates/*
      - .gitlab-ci.yml

deploy-db-master-docker:
  stage: deploy
  script:
    - docker build --pull -f Dockerfile.db-test -t "$CONTAINER_DB_TEST_IMAGE" .
    - docker run $CONTAINER_DB_TEST_IMAGE
    - docker build --pull -f Dockerfile.db -t "$CI_REGISTRY_IMAGE:db" .
    - docker push "$CI_REGISTRY_IMAGE:db"
    - docker image tag "$CI_REGISTRY_IMAGE:db" "${DOCKER_REGISTRY_IMAGE_DB}"
    - docker login -u "$DOCKER_REGISTRY_USER" -p "$DOCKER_REGISTRY_PASSWORD" $DOCKER_REGISTRY
    - docker push "${DOCKER_REGISTRY_IMAGE_DB}"
  only:
    refs:
      - master
    <<: *db-only-changes

deploy-db:
  stage: deploy
  script:
    - docker build --pull -f Dockerfile.db-test -t "$CONTAINER_DB_TEST_IMAGE" .
    - docker run $CONTAINER_DB_TEST_IMAGE
    - docker build --pull -f Dockerfile.db -t "$CI_REGISTRY_IMAGE:${CI_COMMIT_REF_SLUG}-db" .
    - docker push "$CI_REGISTRY_IMAGE:${CI_COMMIT_REF_SLUG}-db"
  except:
    - master
  only:
    <<: *db-only-changes

# mapserver
.mapserver_only_changes: &mapserver_only_changes
    changes:
      - Dockerfile.mapserver
      - server_conf_templates/var/lib/openbiomaps/*
      - server_conf_templates/usr/lib/cgi-bin/*
      - .gitlab-ci.yml

.build-mapserver-master:
  stage: build
  script:
    - docker build --file Dockerfile.mapserver --pull -t "$CI_REGISTRY_IMAGE:mapserver" .
    - docker push "$CI_REGISTRY_IMAGE:mapserver"
  only:
    refs:
      - master
  <<: *mapserver_only_changes

deploy-mapserver-master-docker:
  stage: deploy
  script:
    - docker build --file Dockerfile.mapserver --pull -t "$CI_REGISTRY_IMAGE:mapserver" .
    - docker image push "$CI_REGISTRY_IMAGE:mapserver"
    - docker image tag "$CI_REGISTRY_IMAGE:mapserver" "${DOCKER_REGISTRY_IMAGE_MAPSERVER}"
    - docker login -u "$DOCKER_REGISTRY_USER" -p "$DOCKER_REGISTRY_PASSWORD" $DOCKER_REGISTRY
    - docker push "${DOCKER_REGISTRY_IMAGE_MAPSERVER}"
  only:
    refs:
      - master
    <<: *mapserver_only_changes

deploy-mapserver:
  stage: deploy
  script:
    - docker build --file Dockerfile.mapserver --pull -t "$CI_REGISTRY_IMAGE:${CI_COMMIT_REF_SLUG}-mapserver" .
    - docker push "$CI_REGISTRY_IMAGE:${CI_COMMIT_REF_SLUG}-mapserver"
  except:
    - master
  only:
    <<: *mapserver_only_changes
